#!/usr/bin/perl

$passwd = "hd6wUKgc89h"; # have a look into create-database.sql
$host = "localhost";

$no = 0;
$errno1 = 0;
$errno2 = 0;
$name = $ARGV[0];

$USE = "usage: ./import.pl <csv file>";
if ((scalar @ARGV) != 1) {
  die "$USE\nwrong argument number\n";
}
if (! -f $name) {
  die "$USE\nfile $name does not exist\n";
}

print `date` . " Start reading csv file\n";

open (FILE, "< $name");
open (TMP, "> /tmp/callcenter.sql");
open (TMPERR1, "> /tmp/callcenter.err1");
open (TMPERR2, "> /tmp/callcenter.err2");

while ($line = <FILE>) {
  chomp ($line);
  $line =~ s/'/\\'/g;
  if ($line =~ /"([^"]*)";"([^"]*)";"([^"]*)";"([^"]*)";"([^"]*)";"([^"]*)";"([^"]*)";"([^"]*)";"([^"]*)";"([^"]*)";"([^"]*)";"([^"]*)";"0([^"]*)";"([^"]*)";"([^"]*)";"([^"]*)"/) {
    ($sal, $first, $sur, $remark, $streetname, $houseno, $street, $loc_sep, $country, $zip, $loc, $no_genre, $pref, $telno, $no1, $no2)
      = ($1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16);
    if (   (($remark eq "") || ($remark =~ /^u\. /))
	&& (!($no_genre eq "Mobil"))
	&& (!($no_genre eq "Telefax"))
	&& (!($pref =~ /^(15.|16.|17.|180|190|800|900)$/))
	&& (!($telno =~ /-/))
	&& (!($sur =~ /[^ ]+ +[^ ]+ +[^ ]/))
	&& (!($sur =~ /[0-9]/))
	&& (!($first =~ /[0-9]/))
	&& (!($sal eq "Firma"))
       )
    {
      print TMP "insert ignore into numbers2 ("
	    . "nextcalldate, salutation, firstname, surname, street,"
	    . " zipcode, location, prefix, phonenumber, completenum)"
	    . " values"
	    . " ('2005-01-01 00:00:00', '$sal', '$first', '$sur',"
	    . " '$street', '$zip', '$loc', '$pref', '$telno',"
	    . " '$pref$telno');\n";
      $no++;
    }
    else {
      print TMPERR2 "$line\n";
      $errno2++;
    }
  }
  else {
    print TMPERR1 "$line\n";
    $errno1++;
  }
}

close FILE;
close TMP;
close TMPERR1;
close TMPERR2;

print "Empty table numbers2\n";

$cmd    = qq|echo "truncate table numbers2;"|
	. " | mysql -u callcenter -p$passwd callcenter -h $host";

print `date` . " Begin with import - $no entries, $errno1 error 1, $errno2 error 2\n";

print `cat /tmp/callcenter.sql | mysql -u callcenter -p$passwd callcenter -h $host` . "\n";
unlink "/tmp/callcenter.sql";
unlink "/tmp/callcenter.err1";
unlink "/tmp/callcenter.err2";

$cmd    = qq|echo "select count(*) from numbers2;"|
	. " | mysql -u callcenter -p$passwd callcenter -h $host";
print "Imported numbers: " . `$cmd` . "\n";

print `date` . " Begin deleting double phonenumber entries\n";

$cmd    = qq|echo "delete from numbers2 using numbers2, numbers |
	. qq|where numbers.completenum=numbers2.completenum;"|
	. " | mysql -u callcenter -p$passwd callcenter -h $host";
print `$cmd` . "\n";

$cmd    = qq|echo "select count(*) from numbers2;"|
	. " | mysql -u callcenter -p$passwd callcenter -h $host";
print "Imported numbers after delete: " . `$cmd` . "\n";

print `date` . " Begin deleting double name/location entries\n";

$cmd    = qq|echo "delete from numbers2 using numbers2, numbers |
	. qq|where numbers.surname=numbers2.surname |
	. qq|and numbers.street=numbers2.street |
	. qq|and numbers.zipcode=numbers2.zipcode |
	. qq|and numbers.location=numbers2.location;"|
	. " | mysql -u callcenter -p$passwd callcenter -h $host";
print `$cmd` . "\n";

$cmd    = qq|echo "select count(*) from numbers2;"|
	. " | mysql -u callcenter -p$passwd callcenter -h $host";
print "Imported numbers after delete: " . `$cmd` . "\n";

print `date` . " Begin deleting negative entries\n";

$cmd    = qq|echo "delete from numbers2 using numbers2, negative |
	. qq|where negative.completenum=numbers2.completenum"|
	. " | mysql -u callcenter -p$passwd callcenter -h $host";
print `$cmd` . "\n";

$cmd    = qq|echo "select count(*) from numbers2;"|
	. " | mysql -u callcenter -p$passwd callcenter -h $host";
print "Imported numbers after delete: " . `$cmd` . "\n";

print `date` . " Begin merging entries\n";

$cmd    = qq|echo "insert into numbers (contract, agent, state, no, |
	. qq|nextcalldate, salutation, firstname, surname, street, |
	. qq|zipcode, location, prefix, phonenumber, completenum, |
	. qq|dirty, normal) |
	. qq|select 0 as contract, 0 as agent, 1 as state, |
	. qq|30000000*rand() as no, |
	. qq|nextcalldate, salutation, firstname, surname, street, |
	. qq|zipcode, location, prefix, phonenumber, completenum, |
	. qq|0 as dirty, 1 as normal from numbers2;"|
	. " | mysql -u callcenter -p$passwd callcenter -h $host";
print `$cmd` . "\n";

print `date` . " Complete.\n";
