#include "phonenumbers.h"
#include "kphoneview.h"
#include <qsqlquery.h>
#include <qdatetimeedit.h>

void KCallWidget::showEvent( QShowEvent* e ) {
  QSqlQuery q0 ( "select now()" );
  if( q0.next() ) {
    QString ts = q0.value( 0 ).toString();
    QDateTime t( QDateTime::fromString( ts, Qt::ISODate ) );
    QDateTimeEditNextcalldate->setDateTime( t );
    printf( "Time set to %s\n", ts.ascii() );
  }
  if( contractFree ) {
    QSqlQuery q1 ( "select count(*) from calls where number = " + QLineEditPkey->text() );
    if( q1.next() ) {
      if( !q1.value( 0 ).toInt() ) { // only if number was not called from this entry...
	QLineEditPrefix->setReadOnly( false );
	QLineEditPhonenumber->setReadOnly( false ); // ... the number can be changed
      }
    }
  }
  //QDateTimeEditNextcalldate->setDateTime( QDateTime::currentDateTime () );
  phoneNumbers::showEvent( e );
}

void KCallWidget::updateWrapper( int status ) {
printf("rem Hangup/Store %s/%d State: %d\n", __FILE__, __LINE__, status);//!rem
  forceDisconnect();

  if (status == 7) { // contract
    if ((QLineEditBirthday->text() == "")
	|| (QLineEditStreet->text() == "")
	|| (QLineEditZipcode->text() == "")
	|| (QLineEditLocation->text() == "")
	|| ((QLineEditBankname->text() == "")
	    && (QLineEditBanknumber->text() == ""))
	|| (QLineEditAccountnumber->text() == "")
	|| ((QLineEditField1->text() == "")
	    && (QLineEditField2->text() == "")
	    && (QLineEditField3->text() == "")
	    && (QLineEditField4->text() == ""))) {
      QMessageBox::information( this,
	tr( "Please complete the form" ),
	tr( "In order to store a contract you have to fill the mandatory fields:\n" )
	+ tr( "Birthday" ) + ", " + tr( "Street" ) + ", " + tr( "Zipcode" ) + ", "
	+ tr( "Location" ) + ",\n"
	+ tr( "at least one of the four contract specific fields,\nat least one of " )
	+ tr( "Bankname" ) + tr( " or " ) + tr( "Banknumber" ) + ",\n"
	+ tr( "Accountnumber" ) + "." );
      return;
    }
  }
  QString StateName;
  switch (status) {
    case 3: StateName = tr( "Not available" ); break;
    case 4: StateName = tr( "Date" ); break;
    case 5: StateName = tr( "Negative List" ); break;
    case 6: StateName = tr( "Yellow" ); break;
    case 7: StateName = tr( "Contract" ); break;
    case 8: StateName = tr( "Delete" ); break;
  }
  if (QMessageBox::question( this,
	tr( "Storing Data" ),
	tr( "Do you really want to save as:\n" ) + StateName + "?",
	tr( "&Yes" ),
	tr( "&No" ),
	QString::null, 0, 1 ))
    return;

  phoneNumbers::updateWrapper( status );

  if ( ( !checkBoxPause->isChecked() ) && ( !contractFree ) )
    clickDial();
  else
    if (!pauseStarted) {
      pauseStarted = 1;
      QSqlQuery q( "insert into pauses ( agent, beginpause, phone ) values (" + agentKey + ", now(), " + phonekey + ")" );
    }
}
