/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
#include "callcenterVars.h"
#include "sounddialog.h"
#include <qmessagebox.h>
#include <qdatetime.h>
#include <qsettings.h>

void phoneNumbers::init() {
  agentInfo->setFilter( "pkey = " + agentKey );
  numberEditor->setFilter( "agent = " + agentKey + " and contract = " + contractKey + " and state >= 2 and state <= 4 and nextcalldate <= now()" );
  contractList->setFilter( "pkey = " + contractKey );
  numberEditor->refresh();
  numberEditor->first();
  contractList->refresh();
  contractList->first();
  QSqlQuery q0( "select count(*) from numbers where agent = " + agentKey + " and contract = " + contractKey + " and state >= 2 and state <= 4 and nextcalldate <= now()" );
  if( q0.next() )
    showNumberCount->setText( q0.value( 0 ).toString() );
  phoneSIPAddress->setText( number + "@" + server );
  QSqlQuery q1( "select field1, field2, field3, field4 from contracts where pkey = " + contractKey );
  if( q1.next() ) {
    labelField1->setText( q1.value( 0 ).toString() );
    labelField2->setText( q1.value( 1 ).toString() );
    labelField3->setText( q1.value( 2 ).toString() );
    labelField4->setText( q1.value( 3 ).toString() );
  }
  QLineEditPkey->hide();
  QLineEditState->hide();
  QLineEditDirty->hide();
  QLineEditCNum->hide();
  if( echoCancel )
    echoCancelBox->setChecked( echoCancel );
//  micro->setValue( (int)(microVol * 25) );
  //QDateTimeEditNextcalldate->setDateTime( QDateTime::currentDateTime () );
  // does not work for the first entry (why?)
  //updateRetry->setEnabled( !(QLineEditState->text() == "3") ); // state: not available
  // QLineEditState->text() does not work for the first entry (why?)
}


void phoneNumbers::updateWrapper( int status )
{
  statusBuffer = status; // for update(): which update button was pressed?
  dirtyBuffer = 0; // entry is stored clean
  numberEditor->update();
  QSqlQuery q0 ( "select count(*) from numbers where agent = " + agentKey + " and contract = " + contractKey + " and state >= 2 and state <= 4 and nextcalldate <= now()" );
  if ( q0.next() ) {
    showNumberCount->setText( q0.value( 0 ).toString() );
    int entries = q0.value( 0 ).toInt();
    if ( contractFree ) {
      if ( entries == 0 ) {
	QSqlQuery q5( "insert into numbers (contract, agent, state, no, nextcalldate, prefix, phonenumber, normal, dirty) values (" + contractKey + ", " + agentKey + ", 2, 0, now(), '', '', 0, 1)" );
	dirtyBuffer = 1;
	QLineEditPrefix->setReadOnly( false );
	QLineEditPhonenumber->setReadOnly( false ); // number can be edited before call
      } // else: there are dates/retries or dirty entries, which have to be processed first
    }
    else if ( entries == 0 ) {
      QMessageBox::information( this, tr( "Information" ), tr( "There are no further numbers to call for this contract." ) );
      QWidget::close();
    }
  }
  numberEditor->refresh();
  numberEditor->first();
  //QDateTimeEditNextcalldate->setDateTime( QDateTime::currentDateTime () );
  QSqlQuery q1 ( "select now()" );
  if( q1.next() ) {
    QString ts = q1.value( 0 ).toString();
    QDateTime t( QDateTime::fromString( ts, Qt::ISODate ) );
    QDateTimeEditNextcalldate->setDateTime( t );
    printf( "Time set to %s\n", ts.ascii() );
  }
//  updateRetry->setEnabled( !(QLineEditState->text() == "3") ); // state: not available
  printf( "store entry: contract=%s state=%d; %s.%03d\n", contractKey.ascii(), status, QTime::currentTime().toString().latin1(), QTime::currentTime().msec() );//!!rem
}


void phoneNumbers::updateWrapperContract()
{
  updateWrapper( 7 ); // state: contract
}


void phoneNumbers::updateWrapperRetry()
{
  if (QLineEditState->text() == "3") {
    updateWrapper( 8 ); // no contract instead of another retry
    return;
  }  // else: retry in 5 hours
  QDateTime t = QDateTime::currentDateTime ();
  QDateTimeEditNextcalldate->setDateTime( t.addSecs( 18000 ) );
  updateWrapper( 3 ); // state: not available (retry)
}


void phoneNumbers::updateWrapperYellow()
{
  updateWrapper( 6 ); // state: yellow
}


void phoneNumbers::updateWrapperRedial()
{
  updateWrapper( 4 ); // state: date
}


void phoneNumbers::updateWrapperDelete()
{
  QString prefix = QLineEditPrefix->text();
  QString phonenumber = QLineEditPhonenumber->text();
  QSqlQuery q( "insert ignore into negative (prefix, phonenumber, completenum) values ('" + prefix + "', '" + phonenumber + "', '" + prefix + phonenumber + "')" );
  updateWrapper( 5 ); // state: negative list
}


void phoneNumbers::updateWrapperNoContract()
{
  updateWrapper( 8 ); // state: no contract
}


void phoneNumbers::printStatus( QSqlRecord *buf )
{
  remarkEditor->setText( buf->value( "remark" ).toString() );
  toCallSIPAddress->setText( countryprefix + buf->value( "prefix" ).toString()
			     + buf->value( "phonenumber" ).toString() + "@" + realm );
  callnumkey = buf->value( "pkey" ).toString(); // store it for the call log mechanism
}


void phoneNumbers::printUpdatedStatus( QSqlRecord *buf )
{
  buf->setValue( "state", statusBuffer );
  buf->setValue( "dirty", dirtyBuffer );
  buf->setValue( "remark", remarkEditor->text() );
}


void phoneNumbers::printChangedStatus( const QSqlRecord *buf )
{
  statusBuffer = buf->value( "state" ).toInt();
  remarkEditor->setText( buf->value( "remark" ).toString() );
  toCallSIPAddress->setText( countryprefix + buf->value( "prefix" ).toString()
			     + buf->value( "phonenumber" ).toString() + "@" + realm );
  callnumkey = buf->value( "pkey" ).toString(); // store it for the call log mechanism
}


void phoneNumbers::updateWrapperLostFocus()
{
  if(   QLineEditSalutation->isModified()
     || QLineEditFirstname_2->isModified()
     || QLineEditSurname_2->isModified()
     || QLineEditBirthday->isModified()
     || QLineEditJob->isModified()
     || QLineEditStreet->isModified()
     || QLineEditZipcode->isModified()
     || QLineEditLocation->isModified()
     || QLineEditPrefix->isModified()
     || QLineEditPhonenumber->isModified()
     || QLineEditPrefix2->isModified()
     || QLineEditPhonenumber2->isModified()
     || QLineEditField1->isModified()
     || QLineEditField2->isModified()
     || QLineEditField3->isModified()
     || QLineEditField4->isModified()
     || QLineEditBankname->isModified()
     || QLineEditBanknumber->isModified()
     || QLineEditAccountnumber->isModified()
     || QLineEditAccountowner->isModified()) {
    dirtyBuffer = 1; // entry is stored dirty (not using the store buttons)
    numberEditor->update();
    QLineEditSalutation->clearModified();
    QLineEditFirstname_2->clearModified();
    QLineEditSurname_2->clearModified();
    QLineEditBirthday->clearModified();
    QLineEditJob->clearModified();
    QLineEditStreet->clearModified();
    QLineEditZipcode->clearModified();
    QLineEditLocation->clearModified();
    QLineEditPrefix->clearModified();
    QLineEditPhonenumber->clearModified();
    QLineEditPrefix2->clearModified();
    QLineEditPhonenumber2->clearModified();
    QLineEditField1->clearModified();
    QLineEditField2->clearModified();
    QLineEditField3->clearModified();
    QLineEditField4->clearModified();
    QLineEditBankname->clearModified();
    QLineEditBanknumber->clearModified();
    QLineEditAccountnumber->clearModified();
    QLineEditAccountowner->clearModified();
printf( "rem %s/%d saved/marked as dirty\n", __FILE__, __LINE__ );//!rem
  }
}


void phoneNumbers::echoCancelChanged( int state )
{
  if(state == QButton::On)
    echoCancel = 1;
  else
    echoCancel = 0;
  QSettings settings;
  settings.writeEntry( "/kallcenter/sound/echoCancel", echoCancel );
  printf( "Echo cancel status changed/saved: %d\n", echoCancel );
}


void phoneNumbers::soundControlStart()
{
  soundDialog = new SoundDialog( this, QString::null, FALSE, Qt::WDestructiveClose ); // a not modal dialog; object will destroy itself when the dialog is closed
  connect( this, SIGNAL( microVolUpdated() ), soundDialog, SLOT( displayMicroVol() ) );
  connect( this, SIGNAL( speakerVolUpdated() ), soundDialog, SLOT( displaySpeakerVol() ) );
  connect( this, SIGNAL( microSigUpdated( double ) ), soundDialog, SLOT( microSigUpdated( double ) ) );
  connect( this, SIGNAL( speakerSigUpdated( double ) ), soundDialog, SLOT( speakerSigUpdated( double ) ) );
  connect( soundDialog, SIGNAL( soundControlStop() ), this, SLOT( soundControlStop() ) );
  soundDialog->show();
}


void phoneNumbers::soundControlStop()
{
  disconnect( this, SIGNAL( microVolUpdated() ), soundDialog, 0 );
  disconnect( this, SIGNAL( speakerVolUpdated() ), soundDialog, 0 );
  disconnect( this, SIGNAL( microSigUpdated( double ) ), soundDialog, 0 );
  disconnect( this, SIGNAL( speakerSigUpdated( double ) ), soundDialog, 0 );
  soundDialog = 0;
}
